; DMGTRIS
; Copyright (C) 2023 - Randy Thiemann <randy.thiemann@gmail.com>

; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <https://www.gnu.org/licenses/>.


IF !DEF(TITLE_MAP_INC)
DEF TITLE_MAP_INC EQU 1


INCLUDE "globals.asm"


SECTION "Title Screen Static Data", ROMX, BANK[BANK_TITLE]
sBUTTONSMode::
    db "NORM"
    db " INV"

sRNGMode::
    db "TGM1"
    db "TGM2"
    db "TGM3"
    db "HELL"
    db "1ROL"

sROTMode::
    db "ARS1"
    db "ARS2"
    db "SEGA"
    db "MYCO"

sDROPMode::
    db "FIRM"
    db "SNIC"
    db "HARD"
    db "LOCK"
    db "NONE"

sCURVEMode::
    db "DMGT"
    db "TGM1"
    db "TGM3"
    db "DEAT"
    db "SHIR"
    db "CHIL"
    db "MYCO"

sHIGMode::
    db "  NO"
    db " YES"

sDisabled::
    db "----"

sFilterMode::
    db "DLRU"
    db "ULRD"
    db "LRUD"
    db "UDLR"
    db "NONE"

sBGMode::
    db "LITE"
    db "DARK"

sTetryRNG::
    db "THIS OPTION WILL"
    db "CHANGE THE WAY  "
    db "PIECES ARE RAN- "
    db "DOMIZED         "

sTetryROT::
    db "THIS OPTION WILL"
    db "CHANGE THE WAY  "
    db "PIECES ROTATE   "
    db "                "

sTetryDROP::
    db "THIS OPTION WILL"
    db "CHANGE THE WAY  "
    db "THE UP AND DOWN "
    db "ARROWS ACT      "

sTetryCURVE::
    db "THIS OPTION WILL"
    db "SELECT A SPEED  "
    db "CURVE TO PLAY ON"
    db "                "

sTetryHIG::
    db "THIS OPTION WILL"
    db "FORCE PIECES TO "
    db "DROP AT THE HI- "
    db "GHEST SPEED     "

sTetrySTART::
    db "THIS OPTION WILL"
    db "CHANGE WHERE YOU"
    db "START IN THE SP-"
    db "EED CURVE       "

sTetryEXITSettings::
    db "OH OKAY THEN-   "
    db "BYE BYE!        "
    db "                "
    db "                "

sTetryProfileNumber::
    db "SELECT THE PRO- "
    db "FILE YOU WOULD  "
    db "LIKE TO EDIT!   "
    db "                "

sTetryProfileInitial1::
    db "THIS IS THE     "
    db "FIRST INITIAL IN"
    db "YOUR NAME!      "
    db "                "

sTetryProfileInitial2::
    db "THIS IS THE     "
    db "SECOND INITIAL  "
    db "IN YOUR NAME!   "
    db "                "

sTetryProfileInitial3::
    db "THIS IS THE     "
    db "THIRD INITIAL IN"
    db "YOUR NAME!      "
    db "                "

sTetryButtons::
    db "THIS OPTION WILL"
    db "CHANGE WHICH WAY"
    db "THE BUTTONS RO- "
    db "TATE THE PIECE! "

sTetryFILTER::
    db "THIS OPTION WILL"
    db "DETERMINE WHICH "
    db "D-PAD BUTTONS   "
    db "HAVE PRIORITY!  "

sTetryBG::
    db "THIS OPTION WILL"
    db "CHANGE THE BACK-"
    db "GROUND COLOR IN-"
    db "GAME!           "

sTetryReset::
    db "THIS OPTION WILL"
    db "RESET THIS PRO- "
    db "FILE TO THE     "
    db "DEFAULT!        "

sTetryEXITProfile::
    db "ARE YOU LEAVING "
    db "ALREADY? I'LL   "
    db "MISS YOU!       "
    db "                "

sTitleAttrs::
    db 7, 7, 7, 7, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    db 1, 1, 1, 1, 3, 3, 3, 1, 3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    db 1, 1, 1, 1, 3, 3, 3, 1, 3, 3, 3, 1, 3, 3, 3, 3, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    db 1, 1, 1, 1, 4, 4, 4, 1, 4, 4, 4, 1, 4, 4, 4, 4, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    db 1, 1, 1, 1, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

sTitleScreenMainMap::
    DB $50,$01,$01,$01,$01,$FC,$F0,$F2,$F8,$FA
    DB $F1,$F3,$F9,$FB,$F4,$F6,$01,$01,$59,$5B
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$A0,$A2,$01,$AA,$B0,$B2,$B8,$BA
    DB $C0,$C2,$C8,$CA,$D0,$D2,$D8,$DA,$E0,$E2
    DB $E8,$EA,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$A1,$A3,$A9,$AB,$B1,$B3
    DB $B9,$BB,$C1,$C3,$C9,$CB,$D1,$D3,$D9,$DB
    DB $E1,$E3,$E9,$EB,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$A4,$A6,$AC,$AE
    DB $B4,$B6,$BC,$BE,$C4,$C6,$CC,$CE,$D4,$D6
    DB $DC,$DE,$E4,$E6,$EC,$EE,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$A5,$A7
    DB $AD,$AF,$B5,$B7,$BD,$BF,$C5,$B7,$CD,$CF
    DB $D5,$D7,$DD,$DF,$E5,$E7,$ED,$EF,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$5D,$01,$1E,$1F,$0C
    DB $1D,$1F,$01,$19,$1A,$1D,$18,$0C,$17,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$01,$01,$01,$5D,$01,$1E
    DB $1F,$0C,$1D,$1F,$01,$0D,$14,$12,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$01,$01,$01,$5D
    DB $01,$1B,$1D,$1A,$11,$14,$17,$10,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$5D,$01,$1E,$10,$1F,$1F,$14,$19,$12
    DB $1E,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$5D,$01,$1D,$10,$0E,$1A,$1D
    DB $0F,$1E,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$5D,$01,$0E,$1D,$10
    DB $0F,$14,$1F,$1E,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$0C,$2A,$0E,$1A
    DB $19,$11,$01,$0D,$2A,$0D,$0C,$0E,$16,$01
    DB $4D,$2A,$19,$0C,$21,$14,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$5E,$5E
    DB $5E,$5E,$5E,$5E,$4A,$5E,$5E,$5E,$5E,$5E
    DB $5E,$4A,$5E,$5E,$5E,$5E,$5E,$5E,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $41,$43,$01,$01,$01,$01,$40,$45,$47,$01
    DB $01,$01,$01,$40,$42,$48,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$5E,$5E,$5E,$5E,$5E,$5E,$5F,$5E
    DB $5E,$5E,$5E,$5E,$5E,$5F,$5E,$5E,$5E,$5E
    DB $5E,$5E,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$44,$46,$01,$01,$01,$01
    DB $40,$49,$4B,$01,$01,$01,$01,$40,$4C,$4E
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00
sTitleScreenMainMapEnd::

sTitleScreenSettingsMap::
    DB $01,$01,$01,$01,$01,$01,$1E,$10,$1F,$1F
    DB $14,$19,$12,$1E,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$5D,$01,$1D,$19,$12,$01
    DB $18,$1A,$0F,$10,$01,$01,$01,$01,$28,$01
    DB $01,$01,$01,$29,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5D,$01,$1D,$1A
    DB $1F,$01,$18,$1A,$0F,$10,$01,$01,$01,$01
    DB $28,$01,$01,$01,$01,$29,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$5D,$01
    DB $0F,$1D,$1A,$1B,$01,$18,$1A,$0F,$10,$01
    DB $01,$01,$28,$01,$01,$01,$01,$29,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $5D,$01,$1E,$1B,$10,$10,$0F,$01,$0E,$20
    DB $1D,$21,$10,$01,$28,$01,$01,$01,$01,$29
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$5D,$01,$0C,$17,$22,$0C,$24,$1E
    DB $01,$04,$02,$12,$01,$01,$28,$01,$01,$01
    DB $01,$29,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$5D,$01,$1E,$1F,$0C,$1D
    DB $1F,$01,$17,$10,$21,$10,$17,$01,$28,$01
    DB $01,$01,$01,$29,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5D,$01,$0D,$0C
    DB $0E,$16,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$0C,$2A,$0E,$1A,$19,$11
    DB $01,$0D,$2A,$0D,$0C,$0E,$16,$01,$4D,$2A
    DB $19,$0C,$21,$14,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5E,$5E,$5E,$5E
    DB $5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E
    DB $5E,$5E,$5E,$5E,$5E,$5E,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$30,$32,$38,$3A,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$31,$33,$39,$3B
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$34,$36
    DB $3C,$3E,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $35,$37,$3D,$3F,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00
sTitleScreenSettingsMapEnd::

sTitleScreenCreditsMap::
    DB $01,$01,$01,$01,$01,$01,$0E,$1D,$10,$0F
    DB $14,$1F,$1E,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$22,$1D,$14,$1F,$1F,$10
    DB $19,$01,$0D,$24,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$2A,$01,$1B,$0C
    DB $19,$0F,$1A,$1D,$0C,$01,$19,$1A,$21,$0C
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $22,$14,$1F,$13,$01,$13,$10,$17,$1B,$01
    DB $11,$1D,$1A,$18,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$2A,$01,$0E,$1D,$10,$10,$1B,$10
    DB $1D,$0E,$1D,$0C,$11,$1F,$24,$1F,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$2A,$01,$17,$14,$19,$0F
    DB $1F,$1A,$0D,$14,$0C,$1E,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$2A,$01,$1F,$10
    DB $1B,$1B,$17,$10,$1E,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$2A,$01
    DB $0C,$19,$1F,$1A,$19,$10,$1D,$12,$1A,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $2A,$01,$25,$0C,$1B,$13,$1A,$0F,$09,$09
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$2A,$01,$0D,$0D,$0D,$0D,$0D,$1D
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$2A,$01,$0C,$23,$08,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$2A,$01,$0D,$10
    DB $22,$0C,$1D,$10,$01,$01,$01,$01,$01,$01
    DB $01,$01,$56,$56,$56,$56,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$2A,$01
    DB $1F,$0C,$1B,$01,$58,$5A,$01,$01,$01,$01
    DB $01,$01,$01,$01,$30,$32,$38,$3A,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $2A,$01,$12,$0D,$0F,$10,$21,$01,$58,$5A
    DB $01,$01,$01,$01,$01,$01,$31,$33,$39,$3B
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$34,$36
    DB $3C,$3E,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$0D,$2A,$0D,$0C,$0E,$16
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $35,$37,$3D,$3F,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00
sTitleScreenCreditsMapEnd::

sTitleScreenProfileMap::
    DB $01,$01,$01,$01,$01,$01,$1B,$1D,$1A,$11
    DB $14,$17,$10,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$5D,$01,$19,$20,$18,$0D
    DB $10,$1D,$01,$01,$01,$01,$01,$01,$28,$01
    DB $29,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5D,$01,$14,$19
    DB $14,$1F,$14,$0C,$17,$01,$03,$01,$01,$01
    DB $28,$01,$29,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$5D,$01
    DB $14,$19,$14,$1F,$14,$0C,$17,$01,$04,$01
    DB $01,$01,$28,$01,$29,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $5D,$01,$14,$19,$14,$1F,$14,$0C,$17,$01
    DB $05,$01,$01,$01,$28,$01,$29,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$5D,$01,$0D,$20,$1F,$1F,$1A,$19
    DB $1E,$01,$01,$01,$01,$01,$28,$01,$01,$01
    DB $01,$29,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$5D,$01,$0F,$2A,$1B,$0C
    DB $0F,$01,$11,$14,$17,$1F,$10,$1D,$28,$01
    DB $01,$01,$01,$29,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5D,$01,$0D,$0C
    DB $0E,$16,$12,$1D,$1A,$20,$19,$0F,$01,$01
    DB $28,$01,$01,$01,$01,$29,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$5D,$01
    DB $1D,$10,$1E,$10,$1F,$01,$1B,$1D,$1A,$11
    DB $14,$17,$10,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $5D,$01,$0D,$0C,$0E,$16,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$0C,$2A,$0E,$1A,$19,$11
    DB $01,$0D,$2A,$0D,$0C,$0E,$16,$01,$4D,$2A
    DB $19,$0C,$21,$14,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$5E,$5E,$5E,$5E
    DB $5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E,$5E
    DB $5E,$5E,$5E,$5E,$5E,$5E,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$30,$32,$38,$3A,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$31,$33,$39,$3B
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$34,$36
    DB $3C,$3E,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $35,$37,$3D,$3F,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00
sTitleScreenProfileMapEnd::

sTitleScreenRecordsMap::
    DB $01,$01,$01,$01,$01,$01,$01,$1E,$0E,$1A
    DB $1D,$10,$1E,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$01,$01,$01,$01,$01,$01
    DB $55,$28,$23,$23,$23,$23,$29,$5C,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $03,$53,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$04,$53,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$05,$53,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$06,$53,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$07,$53
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $08,$53,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$09,$53,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$0A,$53,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$0B,$53,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$03,$54
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
    DB $01,$01,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$0D,$2A,$0D,$0C,$0E,$16
    DB $01,$4D,$2A,$19,$0C,$21,$14,$01,$1E,$17
    DB $2A,$1D,$1E,$1F,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
    DB $00,$00
sTitleScreenRecordsMapEnd::


ENDC
